<?php
//将本php文件放置到kodbox目录下即可
//*********先配置如下参数******
//有疑问可邮件uu@uu8f.com

/*
注意，在尾部增加一行授权密码如下
$config['settings']['apiLoginToken'] = '自己定义一个API授权密码';
*/
include("config/setting_user.php");

//设置你的kodbox文件地址
$serUrl="http://localhost/kodbox";

//设置你的文件管理账号
$username="admin";

//清除全部版本时，默认间隔时间（秒），如0.2表示200ms，5表示5秒
$sleepTime=0.2;

/*
配置完成
使用方法：
1、删除单个历史版本文件
方法：http://server/boxfix.php?ac=delHistory&id=文件fileID&sourceID=文件sourceID
（在mysql表io_source_history表中查询fileID和sourceID，结合io_file和io_source表判断，关键看文件名，fileID和sourceID，一个sourceID可能关联多个fileID(其中只有一个是当前版本，其他是历史版本)

2、删除全部历史版本
方法：http://server/boxfix.php?ac=clearHistory
浏览器打开，脚本会依次查询io_source_history表中的纪录，并通过接口删除历史纪录和文件

*/


$AccessToken=getAccessToken($username);
//$AccessToken获取后，可以重复使用，有兴趣可以获取一次然后写死，提升性能
//$AccessToken="791bnoq4_DY4C2jnCmamW7hVAHXilW5IVNFDWCvM977ZIStXqGkivK_vHhiSAFtjJ8UhH2DKK-cDLo1M6A";
//echo $AccessToken;
//echo(file_get_contents("$serUrl/index.php?user/view/checkCode&accessToken=$AccessToken"));
//delHistory(380,493);


$conn = new mysqli($config['database']['DB_HOST'], $config['database']['DB_USER'], $config['database']['DB_PWD'], $config['database']['DB_NAME']);
mysqli_set_charset($conn,'utf8');



/////////////////

$ac="";
if (isset($_GET["ac"])){
    $ac=$_GET["ac"];
}

switch ($ac) {
    case 'delHistory':
        delHistory($_GET["id"],$_GET["sourceid"]);
        break;
    
    case 'clearHistory':
        clearHistory();
        break;
    
    default:
        echo "AC?";
        break;
}



//////////////////////////

function clearHistory(){
    $hisRes=getV("SELECT CONCAT(id,'#',sourceID,'#',size) from io_source_history limit 1");
    if ($hisRes!=false){
        $id=explode("#",$hisRes)[0];
        $sourceid=explode("#",$hisRes)[1];
        $sizeM=round(explode("#",$hisRes)[2]/1024/1024,2);
        $res=delHistory($id,$sourceid);
        $res.="<p>已删除ID:$id (文件大小：$sizeM M)</p>";
        $haven=getV("SELECT count(id) from io_source_history");
        $res.="<p>还有".$haven."条</p>";
        $res.='<meta http-equiv="refresh" content="'.$sleepTime.'">';
        echo $res;
    }else{
        echo "ALLDone!";
    }
}



function delHistory($id,$sourceid){
    $resArr=boxAC("explorer/history/remove",array("path"=>"{source:$sourceid}/","id"=>$id));
    return($resArr->data);
}

function boxAC($ac,$data){
    global $AccessToken,$serUrl;
    $urlac="index.php?$ac";
    $url="$serUrl/$urlac&accessToken=$AccessToken";
    $postRes=postCurl($url,$data);
    return json_decode($postRes);
}


function getAccessToken($username){
    global $config,$serUrl;
    $apiLoginToken=$config['settings']['apiLoginToken'];
    //echo "TK:".$tk;
    $loginToken=base64_encode($username)."|".md5($username.$apiLoginToken);
    //echo $loginToken;
    $loginRes=file_get_contents("$serUrl/?user/index/loginSubmit&loginToken=".$loginToken);
    //echo $loginRes;
    $resJson=json_decode($loginRes);
    if ($resJson->data =="ok"){
        $accessToken=$resJson->info;
        return $accessToken;
    }else{
        return $resJson->data;
    }
}





function postCurl($url,$data){
  /**
  if($type == 'json'){
      $data = json_encode($data);//对数组进行json编码
      $header= array("content-type: application/x-www-form-urlencoded; charset=UTF-8");
  }
  **/
  $curl = curl_init();
  curl_setopt($curl,CURLOPT_URL,$url);
  curl_setopt($curl,CURLOPT_POST,1);
  curl_setopt($curl,CURLOPT_SSL_VERIFYPEER,false);
  curl_setopt($curl,CURLOPT_SSL_VERIFYHOST,false);
  if(!empty($data)){
      curl_setopt($curl,CURLOPT_POSTFIELDS,$data);
  }
  curl_setopt($curl,CURLOPT_RETURNTRANSFER,1);
  //curl_setopt($curl,CURLOPT_HTTPHEADER,$header);
  $res = curl_exec($curl);
  if(curl_errno($curl)){
      echo 'Error+'.curl_error($curl);
  }
  curl_close($curl);
  return $res;
}



function getV($sql){
    global $conn;
    $result = $conn->query($sql);
    if ($result->num_rows > 0) {
        $res=mysqli_fetch_row($result);
        $res=$res[0];
    } else {
        $res=false;
    }
    return $res;
}

$conn->close();
//关闭数据库

?>